%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PHY306, Assignment 2, Numerics question template.  IISER Bhopal  2020
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Assignment2

h = 1;
xf = 5;
g = 9.81;
eps = 1e-6;

% discretize x
Nsamples = 500;   % number of timesamples
xsamples = linspace(0,xf,Nsamples); %must not start at 0, cause numerical time diverges there.
dx= xsamples(2)-xsamples(1);

%define initial guess for slide
zguess = XXX;

% define inequality constraints (z<h)
AA =eye(Nsamples);
bb = h*ones(Nsamples,1);

% define equality constraints (slide at x=0 must be height h, and at x=l must be height 0)
Aeq = zeros(Nsamples,Nsamples); %define empty matrix
Aeq(1,1)=1;
Aeq(Nsamples,Nsamples)=1;

beq = zeros(Nsamples,1); %define empty vector
beq(1)=h;
beq(Nsamples)=0;

 %matlab constrained minimizer
options = optimoptions('fmincon','Algorithm','active-set','Display','iter');
options.MaxIterations = 500;
options.OptimalityTolerance=1.0000e-8;
options.StepTolerance=1.0000e-9;
options
zout = fmincon(@functional,zguess,AA,bb,Aeq,beq,[],[],[],options);

save(['assignment2_output.mat'])
display(['Wrote assignment2_output.mat'])

%%%%%%%%%%%%%%%%%%%%%%%%
% internal functions
%%%%%%%%%%%%%%%%%%%%%%%%

function Ttot = functional(z_in)

dz = gradient(z_in);         % takes the difference between consecutive elements to calculate the derivative
da = XXXX;	 % pythagoras	
vel =XXX;    % energy conservation

dt = da./(vel+eps); %think about why we need the "+eps"
Ttot = trapz(dt);            % very simple numerical integration 

%keyboard

end % funct

end % main function